/* UDP client (client_udp.c)
 *
 * Name: Ryan Prins
 * Date: Feb 19, 2004
 * INFO 341 - Lab 4
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>

void error(char *);
int main(int argc, char *argv[])
{
   int sock, length, n;
   struct sockaddr_in server, from;
   struct hostent *hp;
   char buffer[256];
   int i = 1;
   
   /* If there are not enough supplied arguements */
   if (argc != 3) { 
	   printf("Usage: <server> <port>\n");
	   exit(1);
   }
   /* Create Socket */
   sock = socket(AF_INET, SOCK_DGRAM, 0);
   if (sock < 0) error("socket");

   server.sin_family = AF_INET;
   hp = gethostbyname(argv[1]);
   if (hp == 0) error("Unknown host");  // cannot find host

   bcopy((char *)hp->h_addr,(char *)&server.sin_addr,hp->h_length);
   server.sin_port = htons(atoi(argv[2]));
   length = sizeof(struct sockaddr_in);

   while(1){
	printf("Client: ");	
	bzero(buffer,256);
	fgets(buffer,255,stdin);
	/* Send to the UDP Socket */
	n = sendto(sock,buffer,strlen(buffer),0,&server,length);
	if (n < 0) error("Sendto");
	/* Receive from the UDP Socket */
	n = recvfrom(sock,buffer,256,0,&from, &length);
	if (n < 0) error("recvfrom");
	write(1,"Server: ",12);
	write(1,buffer,n);
   }
}

/* Print an error message if so needed */
void error(char *msg)
{
    perror(msg);
    exit(0);
}
