/* Creates a UDP Server (server_udp.c)
 *
 * Name: Ryan Prins
 * Date: Feb 19, 2004
 * INFO 341 - Lab 4
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>

void error(char *msg)
{
    perror(msg);
    exit(0);
}

int main(int argc, char *argv[])
{
   int sock, length, fromlen, n;
   struct sockaddr_in server;
   struct sockaddr_in from;
   char buffer[256];

   /* If not enough arguements passed - DO THIS */
   if (argc < 2) {
      fprintf(stderr, "ERROR, no port provided\n");
      exit(0);
   }
   
   /* Create UDP Socket */
   sock=socket(AF_INET, SOCK_DGRAM, 0);
   if (sock < 0) error("Opening socket");
   length = sizeof(server);
   bzero(&server,length);
   server.sin_family=AF_INET;
   server.sin_addr.s_addr=INADDR_ANY;
   server.sin_port=htons(atoi(argv[1]));
   if (bind(sock,(struct sockaddr *)&server,length)<0) 
       error("binding");
   fromlen = sizeof(struct sockaddr_in);

   /* Infinate While Loop To Keep Server Alive */
   while (1) {
	   /* Receive from client */
       n = recvfrom(sock,buffer,1024,0,(struct sockaddr *)&from,&fromlen);
       if (n < 0) error("recvfrom");
	   /* Print Client Text */
       write(1,"Client: ",21);
       write(1,buffer,n);
	   /* Get read to enter text in */
	   printf("Server: ");
	   bzero(buffer,256);
	   fgets(buffer,255,stdin);
       /* Send server input to client */
       n = sendto(sock,buffer,17,0,(struct sockaddr *)&from,fromlen);
       if (n  < 0) error("sendto");
   }
 }

